﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Linq.Expressions;

namespace GenericDemos
{
    class MyClass1
    {
        public MyClass1(int x)
        {

        }
    }

    class MyClass2
    {
        public MyClass2(int x)
        {

        }
    }

    public class Factory<T>
    {
        //Singleton模式所需的内部类
        static class InstanceHolder
        {
            //泛型类Factory<T>.InstanceHolder的静态字段
            public static Func<int, T> Creater;

            static InstanceHolder()
            {
                Type t = typeof(T);

                //取得参数为一个int的构造函数
                ConstructorInfo ctor = t.GetConstructor(
                    new[] { typeof(int) });

                //生成Expression Tree
                var param = Expression.Parameter(typeof(int), "arg");
                var lambda = Expression.Lambda<Func<int, T>>(
                    Expression.New(ctor, param),
                    param);

                //生成的Expression相当于(int arg) => new T(arg)
                //编译成真正的委托

                Creater = lambda.Compile();
            }
        }

        public static T Create(int x)
        {
            return InstanceHolder.Creater(x);
        }
    }

   
}
