﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Reflection;

namespace GenericDemos
{
    class Program
    {
        static void Main(string[] args)
        {


            Stopwatch sw = new Stopwatch();

            sw.Start();
            const int c_ExecutionCount = 1000000;

            for (int i = 0; i < c_ExecutionCount; i++)
            {
                var obj = Factory<MyClass1>.Create(i);
                //var obj = ReflectionFactory<MyClass1>(i);
            }

            sw.Stop();

            Console.WriteLine(sw.ElapsedMilliseconds + "ms");
        }

        public static void Foo<T>()
        {
            Console.WriteLine(TypeDict<T>.Value1); 
        }

        static T ReflectionFactory<T>(int x)
        {
            Type t = typeof(T);
            ConstructorInfo ctor = t.GetConstructor(new[] { typeof(int) });

            return (T)ctor.Invoke(new object[] { x });
        }
    }
}
